/*
 * 3D Engine 
 * mesh.c: 
 * Based on pikuma.com 3D software renderer in C
 * Copyright (c) 2021 986-Studio. All rights reserved.
 *
 * Created by Manoël Trapier on 04/03/2021.
 */

#include <mesh.h>

vec3_t meshVertices[N_MESH_VERTICES] =
{
    [0] = { .x = -1, .y = -1, .z = -1},
    [1] = { .x = -1, .y =  1, .z = -1},
    [2] = { .x =  1, .y =  1, .z = -1},
    [3] = { .x =  1, .y = -1, .z = -1},
    [4] = { .x =  1, .y =  1, .z =  1},
    [5] = { .x =  1, .y = -1, .z =  1},
    [6] = { .x = -1, .y =  1, .z =  1},
    [7] = { .x = -1, .y = -1, .z =  1},
};

face_t meshFaces[N_MESH_FACES] =
{
    /* Front */
    { .a = 1, .b = 2, .c = 3 },
    { .a = 1, .b = 3, .c = 4 },
    /* Right */
    { .a = 4, .b = 3, .c = 5 },
    { .a = 4, .b = 5, .c = 6 },
    /* Back */
    { .a = 6, .b = 5, .c = 7 },
    { .a = 6, .b = 7, .c = 8 },
    /* Left */
    { .a = 8, .b = 7, .c = 2 },
    { .a = 8, .b = 2, .c = 1 },
    /* Top */
    { .a = 2, .b = 7, .c = 5 },
    { .a = 2, .b = 5, .c = 3 },
    /* Bottom */
    { .a = 6, .b = 8, .c = 1 },
    { .a = 6, .b = 1, .c = 4 },
};